#*-* coding: utf-8 *-*
import os
import time
from socket import *
from Antenna import *
from Communicator import * 

class AntCommunicator(Communicator):
    def __init__(self,name):
        self.flag = True
        self.Soc = None
        Communicator.__init__(self,name)
    def Init(self,ip,port):
        self.Ant = Antenna('Antenna')
        self.IP = str(ip)
        self.Port = int(port)
        Communicator.ResetFlag(self)
    def Send(self,dat):
        try :
            self.Soc.sendall(dat)
        except: self.out('* Antenna Socket Error (Send) ')
    def Start(self):
		while 1:
			self.Soc = socket(AF_INET, SOCK_STREAM)
			self.out('Create New Socket')
			try:
				self.Soc.connect((self.IP,self.Port))
				self.out('Connected ({},{})'.format(self.IP, self.Port))
				while self.IsRun() :
					self.Soc.settimeout(5.0)
					line = self.Soc.recv(1024)
					# try:
						# soc.settimeout(5.0)
						# line = soc.recv(1024)
					# except:
						# self.out('AntCommunicator Received Timeout')
					if line[0:2] == '$K' : 
						lines = line.split(',')
						if len(lines) > 3 : 
							# self.out(line)
							if lines[2] == 'STS' : self.Ant.DatProc(line)
							elif lines[2] == 'GPS' : self.Ant.Nmea.BurstGpsProc(line)
						self.SetFlag()
				self.ResetFlag()
			except: self.out('AntCommunicator Retry.... (wait 5sec)')
			time.sleep(5)

	
