#-*- coding:utf-8 -*-
import os
import datetime
import netifaces

class Util:
    @staticmethod
    def SetIPv4(arr): 
        # print "sudo sed -i \"%ds/.*/%s %s/g\" /etc/network/interfaces"%( 14, "address","192.168.1.5")
        # os.system("sudo sed -i \"%ds/.*/%s %s/g\" /etc/network/interfaces"%( 14, "address","192.168.1.5"))
        os.system("sudo sed -i \"{}s/.*/{} {}/g\" /etc/network/interfaces".format(14,"address",arr['Addr']))
        os.system("sudo sed -i \"{}s/.*/{} {}/g\" /etc/network/interfaces".format(15,"netmask",arr['Netmask']))
        os.system("sudo sed -i \"{}s/.*/{} {}/g\" /etc/network/interfaces".format(16,"gateway",arr['Gateway']))
    @staticmethod
    def GetTemperature(): 
        tmp = os.popen("vcgencmd measure_temp").read()
        tmp1 = tmp.split('=')
        tmp2 = tmp1[1].split('\'')
        return float(tmp2[0])
    @staticmethod
    def UTC(): 
        return datetime.datetime.utcnow().strftime('%H%M%S.%f')[:-3]
    @staticmethod
    def Systime(): 
        dt = str(datetime.datetime.now())
        return dt[0:22]
    @staticmethod
    def UpdateNetwork(dat): 
        from Project import pj 

        if netifaces.ifaddresses('eth1')[17][0]['addr'] != dat['Network']['Mac'] :
            mac = dat['Network']['Mac'].split(':')
            tmp = '$KW,MAC,{},{},{},{},{},{},'.format(int(mac[0],16),int(mac[1],16),int(mac[2],16),int(mac[3],16),int(mac[4],16),int(mac[5],16))
            pj.McuComm.Send(tmp)
            print "Update MAC address: {}".format(tmp)
        
        if netifaces.ifaddresses('eth1')[netifaces.AF_INET][0]['addr'] != dat['Network']['Addr'] or netifaces.ifaddresses('eth1')[netifaces.AF_INET][0]['netmask'] != dat['Network']['Netmask'] or  netifaces.gateways()['default'][2][0] != dat['Network']['Gateway'] : 
            Util.SetIPv4(dat['Network'])
            print "Update IPv4 address: {}/{}/{}".format(dat['Network']['Addr'],dat['Network']['Netmask'],dat['Network']['Gateway'])
        # Util.SetIPv4(dat['Network'])
        # os.system("cat /etc/network/interfaces")

        
    